<?php

// Survey database interface class as intermediate for storing data from the site to the RDF database 
require_once 'rdfConstants.php';

// Include RAP Library to write RDF files
include(RDFAPI_INCLUDE_DIR . "RDFAPI.php");

class DashboardCreationDatabaseInterface
{    
    protected $dashboardRDFWriter;
    protected $dashboardRDFReader;
    
    public function __construct($dashID)
    {
        if($dashID == null)
            $dashboardID = md5( uniqid(rand(), true) );
        else
            $dashboardID = $dashID;
        
        $this->dashboardRDFWriter = new DashboardRDFWriter($dashboardID);
        $this->dashboardRDFReader = new DashboardRDFReader($dashboardID);
    }
    
    public function setDashboardInfo($dashboard,$user)
    {
        $dTitle = $dashboard['dashboardTitle'];
        $dDescription = $dashboard['dashboardDescription'];
        
        $dCreatorID = $user['username'];
        
        $this->dashboardRDFWriter->createDashboard($dTitle, $dDescription, $dCreatorID);
        
        $gNumber = 1;
        while (isset($dashboard['graphTitle'.$gNumber]))
        {
            if (isset($dashboard['graphID'.$gNumber]))
                $gID = $dashboard['graphID'.$gNumber];
            else
                $gID = md5( uniqid(rand(), true) );
            $gTitle = $dashboard['graphTitle'.$gNumber];
            $gDescription = $dashboard['graphDescription'.$gNumber];
            
            $gTypes = array();
            $tNumber = 1;
            while(isset($dashboard['g'.$gNumber.'type'.$tNumber]))
            {
                $gTypes[] = $dashboard['g'.$gNumber.'type'.$tNumber];
                $tNumber++;
            }
            $gData = array();
            $dNumber = 1;
            while(isset($dashboard['g'.$dNumber.'datatype'.$tNumber]) && isset($dashboard['g'.$gNumber.'dataid'.$dNumber]))
            {
                $dData = array();
                $dData['type'] = $dashboard['g'.$gNumber.'datatype'.$dNumber];
                $dData['id'] = $dashboard['g'.$gNumber.'dataid'.$dNumber];
                $gData[] = $dData;
                $dNumber++;
            }
        }
    }
}

?>
